param rho := 1.0E+08;

param n = 10;

param A{i in 1..n, j in 1..n}, := 1.0 / (i + j - 1);

param sol{i in 1..n}, := -1.0 + 2.0 * Uniform01();

param b{i in 1..n}, := sum{j in 1..n} A[i,j] * sol[j];

param btilde{i in 1..n}, := b[i] * ( ( 1.0 - 1.0E-06 ) + 2.0E-06 * Uniform01() );

var x{i in 1..n} >= -1.0E+20, <= 1.0E+20, := 0.0;

minimize Obj:
     sum {i in 1..n} ( ( sum{j in 1..n} A[i,j] * x[j] ) - btilde[i] )^2 + 
     rho * sum{j in 1..n} x[j]^2;

option randseed 1;

option solver algencan;
solve;

display rho;
display sum {i in 1..n} ( ( sum{j in 1..n} A[i,j] * x[j] ) - btilde[i] )^2;
display sum{j in 1..n} x[j]^2;

#param rho := 1.0E-08;
#parcela A: 1.39806e-09
#parcela B: 1.26852

#param rho := 1.0E-07;
#parcela A: 8.59881e-09
#parcela B: 1.02617

#param rho := 1.0E-06;
#parcela A: 1.19893e-07
#parcela B: 0.805127

#rho = 1e-05
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 2.26436e-06
#sum{j in 1 .. n} x[j]^2 = 0.240953

#rho = 0.0001
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 5.76675e-06
#sum{j in 1 .. n} x[j]^2 = 0.092704

#rho = 0.001
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 2.09608e-05
#sum{j in 1 .. n} x[j]^2 = 0.056174

#rho = 0.01
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 7.05625e-05
#sum{j in 1 .. n} x[j]^2 = 0.0371759

#rho = 0.1
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.000270953
#sum{j in 1 .. n} x[j]^2 = 0.0325933

#rho = 1
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.00664977
#sum{j in 1 .. n} x[j]^2 = 0.0191858

#rho = 10
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.0609618
#sum{j in 1 .. n} x[j]^2 = 0.00185668

#rho = 100
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.097731
#sum{j in 1 .. n} x[j]^2 = 2.98495e-05

#rho = 1000
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103161
#sum{j in 1 .. n} x[j]^2 = 3.15159e-07

#rho = 10000
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103729
#sum{j in 1 .. n} x[j]^2 = 3.16902e-09

#rho = 1e+05
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103786
#sum{j in 1 .. n} x[j]^2 = 3.17077e-11

#rho = 1e+06
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103792
#sum{j in 1 .. n} x[j]^2 = 3.17095e-13

#rho = 1e+07
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103792
#sum{j in 1 .. n} x[j]^2 = 3.17096e-15

#rho = 1e+08
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 0.103792
#sum{j in 1 .. n} x[j]^2 = 3.17097e-17

#ALGENCAN-OTR
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 2.96035e-15
#sum{j in 1 .. n} x[j]^2 = 318.613

#ALGENCAN
#sum{i in 1 .. n} (sum{j in 1 .. n} A[i,j]*x[j] - btilde[i])^2 = 4.22788e-17
#sum{j in 1 .. n} x[j]^2 = 7174410

load curvaL.dat;
plot(sqrt(curvaL(:,1)),sqrt(curvaL(:,2)));
plot(sqrt(2.96035e-15),sqrt(318.613),'x');
plot(sqrt(4.22788e-17),sqrt(7174410),'o');