# Minimizar - exp(1/||x||^2)
# sujeta a
# sum x_i = 1.
# Punto inicial: Y... algo cercano de (1/n,,,1/n)...que es la solucion verdadera.
# Variacion: sujeta a cualquier poliedro que no contenga al cero.

param n := 10;

var x {i in 1..n} >= -1.0E+20, <= 1.0E+20, := ( 1.0 / n ) * ( 0.9 + 0.2 * Uniform01() ) ;

minimize Obj:
    - exp( 1.0 / ( ( sum{i in 1..n} x[i]^2 ) + 0.01 ) );

subject to R:
    sum{i in 1..n} x[i] = 1.0;

option randseed 1;
